{
GETRC5 - dekoder RC5 korzystajacy z przystawki IgorPlug
(C) Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}

uses tmr,crt;

const
 adr:word=$3F8;
 MCR=4;
 MSR=6;
 DSR=32;

var
 stan,i,j,k,adres,komenda:byte;
 licznik:byte;
 czas:array[0..40]of byte;
 RC5:array[1..14]of byte;
 RC5Bif:array[0..29]of byte;
 s:string;


{$F+}
procedure int8;interrupt;
begin
 inc(licznik);
 port[$20]:=$20;
end;



label koniec;

begin
 writeln('GETRC5 - Odbiornik podczerwieni w kodzie RC5');

 s:=ParamStr(1);
 case s[1] of
 '1':adr:=$3f8;
 '2':adr:=$2f8;
 else begin
   writeln('Uzycie: GETRC5 par1'#10#13'gdzie par1 to numer portu szeregowego');
   halt(1);
  end;
 end;
 writeln('Oczekiwanie na paczke IR...  Nacisnij ESC aby zakonczyc');
 port[adr+MCR]:=3;
 ff:=10000; {krok licznika 100us}
 StartInt(@int8);
 zabron;

  repeat
   i:=0;
   FillChar(czas,sizeof(czas),0);
   while (i<40) do begin
    stan:=port[adr+MSR];
    licznik:=0;
    zezwol;
    while (port[adr+MSR]=stan)and(licznik<101) do if port[$60]=1 then goto koniec;
    zabron;
    if licznik>100 then break;
    if licznik>1 then begin
     czas[i]:=licznik;
     inc(i);
    end;
   end;

   {Dekoduj}
   {Czy RC5? => sprawdz czy sa bity startu i toggle}
   if (czas[1]>6)and(czas[1]<12)and(czas[2]>6)and(czas[2]<12)and
      (((czas[3]>6)and(czas[3]<12))or((czas[3]>15)and(czas[3]<21)))
   then begin
    czas[i]:=9;
{    writeln(#10#13'ilosc probek=',i);
    for j:=1 to i do begin
     write(',',czas[j]:2);
     if j mod 2=0 then write('P') else write('N');
    end;

    writeln(#10#13'DekodowanieBI:');}
    FillChar(RC5Bif,sizeof(RC5Bif),0);

    j:=1;
    k:=1;
    while j<i do begin
     case j mod 2 of
     0: if (czas[j]>6)and(czas[j]<12)then begin
         RC5Bif[k]:=0;
         inc(k);
         inc(j);
        end else if (czas[j]>15)and(czas[j]<21) then begin
         RC5Bif[k]:=0;
         inc(k);
         RC5Bif[k]:=0;
         inc(k);
         inc(j);
        end else break;

      1:if (czas[j]>6)and(czas[j]<12)then begin
         RC5Bif[k]:=1;
         inc(k);
         inc(j);
        end else if (czas[j]>15)and(czas[j]<21) then begin
         RC5Bif[k]:=1;
         inc(k);
         RC5Bif[k]:=1;
         inc(k);
         inc(j);
        end else break;
     end;
    end;
  {  writeln('k=',k);
    for j:=0 to 29 do write(',',RC5Bif[j]:2); writeln;


    writeln('Dekodowanie RC');}
    k:=0;
    for j:=1 to 14 do begin
     if (RC5Bif[k]=0)and(RC5Bif[k+1]=1)then RC5[j]:=1 else RC5[j]:=0;
     inc(k,2);
    end;
{    for j:=1 to 14 do write(',',RC5[j]:2);}
    adres:=0;
    komenda:=0;
    for i:=4 to 8 do if RC5[i]=1 then adres:=adres or (1 shl (8-i));
    for i:=9 to 14 do if RC5[i]=1 then komenda:=komenda or (1 shl (14-i));
    writeln('RC5: adres=',adres,' komenda=',komenda);
    {delay(20);}
   end else if (czas[1]>23)and(czas[1]<31) then writeln('SONY - nieobslugiwany przez program');
  until false;

koniec:
 StopInt;
 while keypressed do ReadKey;

end.