{
     SENDRC5
(C) Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}

uses keyboard,tmr;

type Tbit=0..1;

var
 bitRC5:array[1..14]of Tbit;
 bitRC5bif:array[1..29]of Tbit;
 adres:word; {portu szeregowego}
 licznik:byte;
 koniec:boolean;

{$F+}
procedure int8;interrupt;
begin
 port[adres+3]:=bitRC5bif[licznik]*64;
 inc(licznik);
 if licznik=30 then koniec:=true;
 port[$20]:=$20;
end;
{$F-}



function bit(pozycja,bajt:byte):Tbit;
begin
 bit:=0;
 if (bajt and (1 shl pozycja))>0 then bit:=1;
end;


procedure SendRC5(adres,komenda:byte);
var i:byte;
begin
 bitRC5[1]:=1;  { 2 x bity startu }
 bitRC5[2]:=1;
 bitRC5[3]:=0;  { bit kontrolny - "parity"}
 bitRC5[4]:=bit(4,adres);  { 4 bit adress }
 bitRC5[5]:=bit(3,adres);  { 3 bit adress }
 bitRC5[6]:=bit(2,adres);  { 2 bit adress }
 bitRC5[7]:=bit(1,adres);  { 1 bit adress }
 bitRC5[8]:=bit(0,adres);  { 0 bit adress }
 bitRC5[9]:=bit(5,komenda);  { 5 bit command }
 bitRC5[10]:=bit(4,komenda); { 4 bit command }
 bitRC5[11]:=bit(3,komenda); { 3 bit command }
 bitRC5[12]:=bit(2,komenda); { 2 bit command }
 bitRC5[13]:=bit(1,komenda); { 1 bit command }
 bitRC5[14]:=bit(0,komenda); { 0 bit command }

 for i:=1 to 14 do  {koduj bifazowo}
 if bitRC5[i]=1 then begin
  bitRC5bif [i*2-1]:=0;
  bitRC5bif [2*i]:=1;
 end else begin
  bitRC5bif [i*2-1]:=1;
  bitRC5bif [2*i]:=0;
 end;
 bitRC5bif[29]:=0;
 licznik:=1;
 koniec:=false;
 zezwol;
 repeat until koniec;
 zabron;
end;

procedure InicjujTimer;
begin
 ff:=1124; {=1/889us czestotliwosc "probkowania"}
 StartInt(@int8);
 zabron;
end;

procedure ZamknijTimer;
begin
 StopInt;
end;

var
 klawisz:array[1..10]of char;
 adress,komenda:array[1..10]of byte;
 i:byte;
 f:text;
 c:char;
 s:string;

begin
 s:=ParamStr(1);
 case s[1] of
 '1':adres:=$3f8;
 '2':adres:=$2f8;
 else adres:=0;
 end;
 if (ParamCount<>1)or(adres=0) then begin
  writeln('Uzycie: sendrc5 par1');
  writeln('Program nadaje komendy RC5 przypisane do klawiszy - dane pobiera z pliku sendrc5');
  writeln('par1 - numer portu szeregowego');
  halt(1);
 end;

 assign(f,'sendrc5');
 reset(f);
 writeln('Nacisnij ESC aby zakonczyc.'#10#13'Przypisales nastepujace klawisze:');
 writeln('Klawisz  adres  komenda');
 for i:=1 to 10 do begin
  if eof(f) then break;
  readln(f,klawisz[i],adress[i],komenda[i]);
  writeln(klawisz[i]:3,adress[i]:10,komenda[i]:10);
 end;
 close(f);

 InicjujTimer;
 repeat
  c:=ReadKey;
  i:=pos(c,klawisz);
  if i<>0 then begin
   writeln('Wysylam:',klawisz[i]:3,adress[i]:10,komenda[i]:10);
   SendRC5(adress[i],komenda[i]);
  end;
 until c=#27;
 ZamknijTimer;
end.
